package com.ekexiu.portal.dao;

import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.util.PageQueryResult;

import com.ekexiu.portal.po.Consult;
import com.ekexiu.portal.po.Professor;
import com.ekexiu.portal.pojo.EditProfessor;

@DAO
public abstract class ConsultDao {
	@Insert
	public abstract int insert(Connection con, Consult consult) throws SQLException;
	
	public int updateFinishTime(Connection con,String consultId,int consultStatus) throws SQLException{
        int _m_2 = 1;
        String sql ="UPDATE CONSULT SET FINISH_TIME= TO_CHAR(NOW(),'YYYYMMDDHH24MISS'),CONSULT_STATUS= ? WHERE CONSULT_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
        	ps.setInt(_m_2++, consultStatus);
            ps.setString(_m_2++,consultId);
            return ps.executeUpdate();
        }finally{
            try{ps.close();}catch(Exception _m_3){}
        }
    }
	
	public int updateRevoveryTime(Connection con,String consultId) throws SQLException{
        int _m_1 = 1;
        String sql ="UPDATE CONSULT SET REVOVERY_TIME= TO_CHAR(NOW(),'YYYYMMDDHH24MISS') WHERE CONSULT_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(_m_1++,consultId);
            return ps.executeUpdate();
        }finally{
            try{ps.close();}catch(Exception _m_2){}
        }
    }
	
	public int updateAssess(Connection con, String consultId, int assessStatus, int assessStar, String assessContant) throws SQLException{
        int _m_2 = 1;
        boolean _m_3 = null == assessContant;
        String sql ="UPDATE CONSULT SET ASSESS_TIME= TO_CHAR(NOW(),'YYYYMMDDHH24MISS'),ASSESS_CONTANT= ?,ASSESS_STAR= ?,ASSESS_STATUS= ? WHERE CONSULT_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            if(_m_3){
                ps.setNull(_m_2++,12);
            }else{
                ps.setString(_m_2++,assessContant);
            }
            ps.setInt(_m_2++,assessStar);
            ps.setInt(_m_2++, assessStatus);
            ps.setString(_m_2++,consultId);
            return ps.executeUpdate();
        }finally{
            try{ps.close();}catch(Exception _m_4){}
        }
    }
	
	public int updateThanks(Connection con,String consultId,int thanksStatus,BigDecimal thanksMoney) throws SQLException{
        int _m_2 = 1;
        boolean _m_3 = null == thanksMoney;
        String sql ="UPDATE CONSULT SET THANKS_TIME= TO_CHAR(NOW(),'YYYYMMDDHH24MISS'),THANKS_MONEY= ?,THANKS_STATUS= ? WHERE CONSULT_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            if(_m_3){
                ps.setNull(_m_2++,3);
            }else{
                ps.setBigDecimal(_m_2++,thanksMoney);
            }
            ps.setInt(_m_2++,thanksStatus);
            ps.setString(_m_2++,consultId);
            return ps.executeUpdate();
        }finally{
            try{ps.close();}catch(Exception _m_4){}
        }
    }
	
	@SelectOne
	@Nullable
	public abstract Consult query(Connection con, String consultId) throws SQLException;
	
	public Consult queryPro(Connection con,String consultId) throws SQLException{
        int _m_1 = 1;
        String sql = "SELECT CONSULT_ID,CONSULT_TYPE,CONSULT_TITLE,CONSULT_CONTANT,PROFESSOR_ID,CONSULTANT_ID,CONSULT_STATUS,FINISH_TIME,ASSESS_STATUS,ASSESS_STAR,ASSESS_CONTANT,ASSESS_TIME,THANKS_STATUS,THANKS_MONEY,THANKS_TIME,REVOVERY_TIME,CONSULT.CREATE_TIME,PROFESSOR.NAME FROM CONSULT LEFT JOIN PROFESSOR ON CONSULT.CONSULTANT_ID = PROFESSOR.ID WHERE CONSULT_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(_m_1++,consultId);
            ResultSet rs = ps.executeQuery();
            try{
                if(rs.next()){
                    Consult _result = new Consult();
                    _result.setConsultId(rs.getString(1));
                    _result.setConsultType(rs.getString(2));
                    _result.setConsultTitle(rs.getString(3));
                    _result.setConsultContant(rs.getString(4));
                    _result.setProfessorId(rs.getString(5));
                    Professor professor = new Professor();
                    professor.setId(rs.getString(6));
                    _result.setConsultStatus(rs.getInt(7));
                    String _m_2 = rs.getString(8);
                    if(rs.wasNull()){
                        _m_2 = null;
                    }
                    _result.setFinishTime(_m_2);
                    _result.setAssessStatus(rs.getInt(9));
                    _result.setAssessStar(rs.getInt(10));
                    String _m_3 = rs.getString(11);
                    if(rs.wasNull()){
                        _m_3 = null;
                    }
                    _result.setAssessContant(_m_3);
                    String _m_4 = rs.getString(12);
                    if(rs.wasNull()){
                        _m_4 = null;
                    }
                    _result.setAssessTime(_m_4);
                    _result.setThanksStatus(rs.getInt(13));
                    BigDecimal _m_5 = rs.getBigDecimal(14);
                    if(rs.wasNull()){
                        _m_5 = null;
                    }
                    _result.setThanksMoney(_m_5);
                    String _m_6 = rs.getString(15);
                    if(rs.wasNull()){
                        _m_6 = null;
                    }
                    _result.setThanksTime(_m_6);
                    _result.setRevoveryTime(rs.getString(16));
                    _result.setCreateTime(rs.getString(17));
                    professor.setName(rs.getString(18));
                    _result.setProfessor(professor);
                    return _result;
                }else{
                    return null;
                }
            }finally{
                try{rs.close();}catch(Exception _m_7){}
            }
        }finally{
            try{ps.close();}catch(Exception _m_8){}
        }
    }
	
	public Consult queryCon(Connection con,String consultId) throws SQLException{
        int _m_1 = 1;
        String sql = "SELECT CONSULT_ID,CONSULT_TYPE,CONSULT_TITLE,CONSULT_CONTANT,PROFESSOR_ID,CONSULTANT_ID,CONSULT_STATUS,FINISH_TIME,ASSESS_STATUS,ASSESS_STAR,ASSESS_CONTANT,ASSESS_TIME,THANKS_STATUS,THANKS_MONEY,THANKS_TIME,REVOVERY_TIME,CONSULT.CREATE_TIME,PROFESSOR.NAME FROM CONSULT LEFT JOIN PROFESSOR ON CONSULT.PROFESSOR_ID = PROFESSOR.ID WHERE CONSULT_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(_m_1++,consultId);
            ResultSet rs = ps.executeQuery();
            try{
                if(rs.next()){
                    Consult _result = new Consult();
                    _result.setConsultId(rs.getString(1));
                    _result.setConsultType(rs.getString(2));
                    _result.setConsultTitle(rs.getString(3));
                    _result.setConsultContant(rs.getString(4));
                    Professor professor = new Professor();
                    professor.setId(rs.getString(5));
                    _result.setConsultantId(rs.getString(6));
                    _result.setConsultStatus(rs.getInt(7));
                    String _m_2 = rs.getString(8);
                    if(rs.wasNull()){
                        _m_2 = null;
                    }
                    _result.setFinishTime(_m_2);
                    _result.setAssessStatus(rs.getInt(9));
                    _result.setAssessStar(rs.getInt(10));
                    String _m_3 = rs.getString(11);
                    if(rs.wasNull()){
                        _m_3 = null;
                    }
                    _result.setAssessContant(_m_3);
                    String _m_4 = rs.getString(12);
                    if(rs.wasNull()){
                        _m_4 = null;
                    }
                    _result.setAssessTime(_m_4);
                    _result.setThanksStatus(rs.getInt(13));
                    BigDecimal _m_5 = rs.getBigDecimal(14);
                    if(rs.wasNull()){
                        _m_5 = null;
                    }
                    _result.setThanksMoney(_m_5);
                    String _m_6 = rs.getString(15);
                    if(rs.wasNull()){
                        _m_6 = null;
                    }
                    _result.setThanksTime(_m_6);
                    _result.setRevoveryTime(rs.getString(16));
                    _result.setCreateTime(rs.getString(17));
                    professor.setName(rs.getString(18));
                    _result.setProfessor(professor);
                    return _result;
                }else{
                    return null;
                }
            }finally{
                try{rs.close();}catch(Exception _m_7){}
            }
        }finally{
            try{ps.close();}catch(Exception _m_8){}
        }
    }	
	
	public PageQueryResult<Consult> queryPagePro(Connection con, String professorId, int status, int timeType, int sortType, int pageSize, int pageNo) throws SQLException{
		PageQueryResult<Consult> queryResult = new PageQueryResult<Consult>();
		StringBuilder sql = new StringBuilder();
		sql.append(" WHERE CONSULT.PROFESSOR_ID = ? ");
		if(1 == status) {
			sql.append(" AND CONSULT_STATUS = 0 ");
		}else if(2 == status) {
			sql.append(" AND CONSULT_STATUS = 1 AND THANKS_STATUS = 0 ");
		}else if(3 == status) {
			sql.append(" AND CONSULT_STATUS = 1 AND ASSESS_STATUS = 0 ");
		}else if(4 == status) {
			sql.append(" AND CONSULT_STATUS = 1 ");
		}
		StringBuilder whereSql = sql;
		sql = new StringBuilder();
		sql.append("SELECT COUNT(1) FROM CONSULT");
		if (whereSql.length() > 0) {
			sql.append(whereSql);
		}
		PreparedStatement ps = con.prepareStatement(sql.toString());
		int paramIndex = 1;
		int totalSize = 0;
		try {
			ps.setString(paramIndex++, professorId);
			queryResult.setPageSize(pageSize);
			ResultSet resultSet = ps.executeQuery();
			try {
				resultSet.next();
				totalSize = resultSet.getInt(1);
			} finally {
				try {
					resultSet.close();
				} catch (Exception _m_6) {
				}
			}
		} finally {
			try {
				ps.close();
			} catch (Exception _m_7) {
			}
		}
		queryResult.setTotal(totalSize);
		if (0 == totalSize) {
			queryResult.setPageNo(1);
			queryResult.setData(Collections.<Consult> emptyList());
			return queryResult;
		}
		paramIndex = 1;
		if (1 == pageNo) {
			queryResult.setPageNo(1);
			sql = new StringBuilder();
			sql.append(" SELECT CONSULT_ID,CONSULT_TYPE,CONSULT_TITLE,CONSULT_CONTANT,CONSULT.PROFESSOR_ID,CONSULTANT_ID,CONSULT_STATUS,FINISH_TIME,ASSESS_STATUS,ASSESS_STAR,ASSESS_CONTANT,ASSESS_TIME,THANKS_STATUS,THANKS_MONEY,THANKS_TIME,REVOVERY_TIME,CONSULT.CREATE_TIME,PROFESSOR.NAME,PROFESSOR.DEPARTMENT,PROFESSOR.TITLE,PROFESSOR.ADDRESS,ORGANIZATION.NAME FROM CONSULT LEFT JOIN PROFESSOR ON CONSULT.CONSULTANT_ID = PROFESSOR.ID LEFT JOIN ORGANIZATION ON PROFESSOR.ORG_ID = ORGANIZATION.ID ");
			if (whereSql.length() > 0) {
				sql.append(whereSql);
			}
			if(0 == timeType) {
				sql.append(" ORDER BY CONSULT.CREATE_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(1 == timeType) {
				sql.append(" ORDER BY REVOVERY_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(2 == timeType) {
				sql.append(" ORDER BY FINISH_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}
			sql.append(" LIMIT ").append(pageSize);
		} else {
			int _pageSize = totalSize / pageSize;
			if (totalSize % pageSize != 0) {
				++_pageSize;
			}
			if (pageNo > _pageSize) {
				pageNo = _pageSize;
			}
			queryResult.setPageNo(pageNo);
			--pageNo;
			int _m_10 = (pageNo * pageSize);
			sql = new StringBuilder();
			sql.append(" SELECT CONSULT_ID,CONSULT_TYPE,CONSULT_TITLE,CONSULT_CONTANT,CONSULT.PROFESSOR_ID,CONSULTANT_ID,CONSULT_STATUS,FINISH_TIME,ASSESS_STATUS,ASSESS_STAR,ASSESS_CONTANT,ASSESS_TIME,THANKS_STATUS,THANKS_MONEY,THANKS_TIME,REVOVERY_TIME,CONSULT.CREATE_TIME,PROFESSOR.NAME,PROFESSOR.DEPARTMENT,PROFESSOR.TITLE,PROFESSOR.ADDRESS,ORGANIZATION.NAME FROM CONSULT LEFT JOIN PROFESSOR ON CONSULT.CONSULTANT_ID = PROFESSOR.ID LEFT JOIN ORGANIZATION ON PROFESSOR.ORG_ID = ORGANIZATION.ID ");
			if (whereSql.length() > 0) {
				sql.append(whereSql);
			}
			if(0 == timeType) {
				sql.append(" ORDER BY CONSULT.CREATE_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(1 == timeType) {
				sql.append(" ORDER BY REVOVERY_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(2 == timeType) {
				sql.append(" ORDER BY FINISH_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}
			sql.append(" LIMIT ").append(pageSize).append(" OFFSET ").append(_m_10);
		}
		ps = con.prepareStatement(sql.toString());
		try {
			ps.setString(paramIndex++, professorId);
			ResultSet rs = ps.executeQuery();
			try {
				List<Consult> _m_11 = new ArrayList<Consult>();
				queryResult.setData(_m_11);
				while (rs.next()) {
					Consult consult = new Consult();
					consult.setConsultId(rs.getString(1));
					consult.setConsultType(rs.getString(2));
					consult.setConsultTitle(rs.getString(3));
					consult.setConsultContant(rs.getString(4));
					consult.setProfessorId(rs.getString(5));
					EditProfessor professor = new EditProfessor();
					professor.setId(rs.getString(6));
					Integer m1 = rs.getInt(7);
					if (rs.wasNull()) {
						m1 = null;
					}
					consult.setConsultStatus(m1);
					String m2 = rs.getString(8);
					if (rs.wasNull()) {
						m2 = null;
					}
					consult.setFinishTime(m2);
					Integer m3 = rs.getInt(9);
					if (rs.wasNull()) {
						m3 = null;
					}
					consult.setAssessStatus(m3);
//					Integer m4 = rs.getInt(10);
//					if (rs.wasNull()) {
//						System.out.println("1");
//						m4 = null;
//					}
//					consult.setAssessStar(m4);
					consult.setAssessStar(rs.getInt(10));
					String m5 = rs.getString(11);
					if (rs.wasNull()) {
						m5 = null;
					}
					consult.setAssessContant(m5);
					String m6 = rs.getString(12);
					if (rs.wasNull()) {
						m6 = null;
					}
					consult.setAssessTime(m6);
					Integer m7 = rs.getInt(13);
					if (rs.wasNull()) {
						m7 = null;
					}
					consult.setThanksStatus(m7);
					BigDecimal m8 = rs.getBigDecimal(14);
					if (rs.wasNull()) {
						m8 = null;
					}
					consult.setThanksMoney(m8);
					String m9 = rs.getString(15);
					if (rs.wasNull()) {
						m9 = null;
					}
					consult.setThanksTime(m9);
					consult.setRevoveryTime(rs.getString(16));
					consult.setCreateTime(rs.getString(17));
					professor.setName(rs.getString(18));
					professor.setDepartment(rs.getString(19));
					professor.setTitle(rs.getString(20));
					String m10 = rs.getString(21);
					if (rs.wasNull()) {
						m10 = null;
					}
					professor.setAddress(m10);
					professor.setOrgName(rs.getString(22));
					consult.setProfessor(professor);
					_m_11.add(consult);
				}
				return queryResult;
			} finally {
				try {
					rs.close();
				} catch (Exception _m_17) {
				}
			}
		} finally {
			try {
				ps.close();
			} catch (Exception _m_18) {
			}
		}
	}
	
	public PageQueryResult<Consult> queryPageCon(Connection con, String consultantId, int status, int timeType, int sortType, int pageSize, int pageNo) throws SQLException{
		PageQueryResult<Consult> queryResult = new PageQueryResult<Consult>();
		StringBuilder sql = new StringBuilder();
		sql.append(" WHERE CONSULT.CONSULTANT_ID = ? ");
		if(1 == status) {
			sql.append(" AND CONSULT_STATUS = 0 ");
		}else if(2 == status) {
			sql.append(" AND CONSULT_STATUS = 1 AND THANKS_STATUS = 0 ");
		}else if(3 == status) {
			sql.append(" AND CONSULT_STATUS = 1 AND ASSESS_STATUS = 0 ");
		}else if(4 == status) {
			sql.append(" AND CONSULT_STATUS = 1 ");
		}
		StringBuilder whereSql = sql;
		sql = new StringBuilder();
		sql.append("SELECT COUNT(1) FROM CONSULT");
		if (whereSql.length() > 0) {
			sql.append(whereSql);
		}
		PreparedStatement ps = con.prepareStatement(sql.toString());
		int paramIndex = 1;
		int totalSize = 0;
		try {
			ps.setString(paramIndex++, consultantId);
			ResultSet resultSet = ps.executeQuery();
			try {
				resultSet.next();
				totalSize = resultSet.getInt(1);
			} finally {
				try {
					resultSet.close();
				} catch (Exception _m_6) {
				}
			}
		} finally {
			try {
				ps.close();
			} catch (Exception _m_7) {
			}
		}
		queryResult.setTotal(totalSize);
		if (0 == totalSize) {
			queryResult.setPageNo(1);
			queryResult.setData(Collections.<Consult> emptyList());
			return queryResult;
		}
		paramIndex = 1;
		if (1 == pageNo) {
			queryResult.setPageNo(1);
			sql = new StringBuilder();
			sql.append(" SELECT CONSULT_ID,CONSULT_TYPE,CONSULT_TITLE,CONSULT_CONTANT,CONSULT.PROFESSOR_ID,CONSULTANT_ID,CONSULT_STATUS,FINISH_TIME,ASSESS_STATUS,ASSESS_STAR,ASSESS_CONTANT,ASSESS_TIME,THANKS_STATUS,THANKS_MONEY,THANKS_TIME,REVOVERY_TIME,CONSULT.CREATE_TIME,PROFESSOR.NAME,PROFESSOR.DEPARTMENT,PROFESSOR.TITLE,PROFESSOR.ADDRESS,ORGANIZATION.NAME FROM CONSULT LEFT JOIN PROFESSOR ON CONSULT.PROFESSOR_ID = PROFESSOR.ID LEFT JOIN ORGANIZATION ON PROFESSOR.ORG_ID = ORGANIZATION.ID ");
			if (whereSql.length() > 0) {
				sql.append(whereSql);
			}
			if(0 == timeType) {
				sql.append(" ORDER BY CONSULT.CREATE_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(1 == timeType) {
				sql.append(" ORDER BY REVOVERY_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(2 == timeType) {
				sql.append(" ORDER BY FINISH_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}
			sql.append(" LIMIT ").append(pageSize);
		} else {
			int _pageSize = totalSize / pageSize;
			if (totalSize % pageSize != 0) {
				++_pageSize;
			}
			if (pageNo > _pageSize) {
				pageNo = _pageSize;
			}
			queryResult.setPageNo(pageNo);
			--pageNo;
			int _m_10 = (pageNo * pageSize);
			sql = new StringBuilder();
			sql.append(" SELECT CONSULT_ID,CONSULT_TYPE,CONSULT_TITLE,CONSULT_CONTANT,CONSULT.PROFESSOR_ID,CONSULTANT_ID,CONSULT_STATUS,FINISH_TIME,ASSESS_STATUS,ASSESS_STAR,ASSESS_CONTANT,ASSESS_TIME,THANKS_STATUS,THANKS_MONEY,THANKS_TIME,REVOVERY_TIME,CONSULT.CREATE_TIME,PROFESSOR.NAME,PROFESSOR.DEPARTMENT,PROFESSOR.TITLE,PROFESSOR.ADDRESS,ORGANIZATION.NAME FROM CONSULT LEFT JOIN PROFESSOR ON CONSULT.PROFESSOR_ID = PROFESSOR.ID LEFT JOIN ORGANIZATION ON PROFESSOR.ORG_ID = ORGANIZATION.ID ");
			if (whereSql.length() > 0) {
				sql.append(whereSql);
			}
			if(0 == timeType) {
				sql.append(" ORDER BY CONSULT.CREATE_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(1 == timeType) {
				sql.append(" ORDER BY REVOVERY_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}else if(2 == timeType) {
				sql.append(" ORDER BY FINISH_TIME ");
				if(0 == sortType) {
					sql.append(" DESC ");
				}
			}
			sql.append(" LIMIT ").append(pageSize).append(" OFFSET ").append(_m_10);
		}
		ps = con.prepareStatement(sql.toString());
		try {
			ps.setString(paramIndex++, consultantId);
			ResultSet rs = ps.executeQuery();
			try {
				List<Consult> _m_11 = new ArrayList<Consult>();
				queryResult.setData(_m_11);
				while (rs.next()) {
					Consult consult = new Consult();
					consult.setConsultId(rs.getString(1));
					consult.setConsultType(rs.getString(2));
					consult.setConsultTitle(rs.getString(3));
					consult.setConsultContant(rs.getString(4));
					EditProfessor professor = new EditProfessor();
					professor.setId(rs.getString(5));
					consult.setConsultantId(rs.getString(6));
					Integer m1 = rs.getInt(7);
					if (rs.wasNull()) {
						m1 = null;
					}
					consult.setConsultStatus(m1);
					String m2 = rs.getString(8);
					if (rs.wasNull()) {
						m2 = null;
					}
					consult.setFinishTime(m2);
					Integer m3 = rs.getInt(9);
					if (rs.wasNull()) {
						m3 = null;
					}
					consult.setAssessStatus(m3);
					consult.setAssessStar(rs.getInt(10));
					String m5 = rs.getString(11);
					if (rs.wasNull()) {
						m5 = null;
					}
					consult.setAssessContant(m5);
					String m6 = rs.getString(12);
					if (rs.wasNull()) {
						m6 = null;
					}
					consult.setAssessTime(m6);
					Integer m7 = rs.getInt(13);
					if (rs.wasNull()) {
						m7 = null;
					}
					consult.setThanksStatus(m7);
					BigDecimal m8 = rs.getBigDecimal(14);
					if (rs.wasNull()) {
						m8 = null;
					}
					consult.setThanksMoney(m8);
					String m9 = rs.getString(15);
					if (rs.wasNull()) {
						m9 = null;
					}
					consult.setThanksTime(m9);
					consult.setRevoveryTime(rs.getString(16));
					consult.setCreateTime(rs.getString(17));
					professor.setName(rs.getString(18));
					professor.setDepartment(rs.getString(19));
					professor.setTitle(rs.getString(20));
					String m10 = rs.getString(21);
					if (rs.wasNull()) {
						m10 = null;
					}
					professor.setAddress(m10);
					professor.setOrgName(rs.getString(22));
					consult.setProfessor(professor);
					_m_11.add(consult);
				}
				return queryResult;
			} finally {
				try {
					rs.close();
				} catch (Exception _m_17) {
				}
			}
		} finally {
			try {
				ps.close();
			} catch (Exception _m_18) {
			}
		}
	}
	
}
